package com.hotwj.platform.resourceManagement.vehicleContract.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.resourceManagement.vehicleContract.domain.HotVehicleContract;
import com.hotwj.platform.resourceManagement.vehicleContract.domain.bo.HotVehicleContractBo;
import com.hotwj.platform.resourceManagement.vehicleContract.domain.vo.HotVehicleContractVo;
import com.hotwj.platform.resourceManagement.vehicleContract.mapper.HotVehicleContractMapper;
import com.hotwj.platform.resourceManagement.vehicleContract.service.IHotVehicleContractService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 车辆合同Service业务层处理
 *
 * @author shihongwei
 * @date 2025-12-15
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotVehicleContractServiceImpl implements IHotVehicleContractService {

    private final HotVehicleContractMapper baseMapper;

    /**
     * 查询车辆合同
     *
     * @param id 主键
     * @return 车辆合同
     */
    @Override
    public HotVehicleContractVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询车辆合同列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 车辆合同分页列表
     */
    @Override
    public TableDataInfo<HotVehicleContractVo> queryPageList(HotVehicleContractBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotVehicleContract> lqw = buildQueryWrapper(bo);
        Page<HotVehicleContractVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的车辆合同列表
     *
     * @param bo 查询条件
     * @return 车辆合同列表
     */
    @Override
    public List<HotVehicleContractVo> queryList(HotVehicleContractBo bo) {
        LambdaQueryWrapper<HotVehicleContract> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotVehicleContract> buildQueryWrapper(HotVehicleContractBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotVehicleContract> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotVehicleContract::getId);
        lqw.eq(bo.getCompanyId() != null, HotVehicleContract::getCompanyId, bo.getCompanyId());
        lqw.eq(bo.getVehicleId() != null, HotVehicleContract::getVehicleId, bo.getVehicleId());
        lqw.eq(StringUtils.isNotBlank(bo.getContractTitle()), HotVehicleContract::getContractTitle, bo.getContractTitle());
        lqw.eq(StringUtils.isNotBlank(bo.getOwnerName()), HotVehicleContract::getOwnerName, bo.getOwnerName());
        lqw.eq(StringUtils.isNotBlank(bo.getContactPhone()), HotVehicleContract::getContactPhone, bo.getContactPhone());
        lqw.eq(bo.getSignDate() != null, HotVehicleContract::getSignDate, bo.getSignDate());
        lqw.eq(bo.getExpireDate() != null, HotVehicleContract::getExpireDate, bo.getExpireDate());
        lqw.eq(StringUtils.isNotBlank(bo.getContractImageUrls()), HotVehicleContract::getContractImageUrls, bo.getContractImageUrls());
        lqw.eq(StringUtils.isNotBlank(bo.getDocAttachmentUrl()), HotVehicleContract::getDocAttachmentUrl, bo.getDocAttachmentUrl());
        lqw.eq(bo.getIsDeleted() != null, HotVehicleContract::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增车辆合同
     *
     * @param bo 车辆合同
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotVehicleContractBo bo) {
        HotVehicleContract add = MapstructUtils.convert(bo, HotVehicleContract.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改车辆合同
     *
     * @param bo 车辆合同
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotVehicleContractBo bo) {
        HotVehicleContract update = MapstructUtils.convert(bo, HotVehicleContract.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotVehicleContract entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除车辆合同信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
